/*--------------------------------------------------------------------------*/
/*		sntpc.c																*/
/*			SNTPNCAg												*/
/*		(C) Copyright 1997 By Tomoaki Nakashima. All right reserved.		*/
/*--------------------------------------------------------------------------*/

#include <stdio.h>
#include <string.h>
#include <winsock.h>
#include <time.h>

#define BUFSIZE		256		/* obt@TCY */
#define RECVSIZE	4096	/* Mobt@TCY */
#define TIMEOUT		3		/* ^CAEgb */

struct NTP_Packet{			/* NTPpPbg */
	int Control_Word;
	int root_delay;
	int root_dispersion;
	int reference_identifier;
	__int64 reference_timestamp;
	__int64 originate_timestamp;
	__int64 receive_timestamp;
	int transmit_timestamp_seconds;
	int transmit_timestamp_fractions;
};

int main(int argc,char **argv)
{

	WORD wVersionRequested;
	int  nErrorStatus;
	WSADATA wsaData;
	char svName[BUFSIZE];						/* T[õhC */
	unsigned short port = 123;					/* T[õ|[gԍ */
	unsigned short local_port = 1024;			/* M|[gԍ */
	int soc;									/* \PbgiSoket Descriptorj */
	unsigned long serveraddr;					/* T[oIPAhX */
	struct hostent *serverhostent;				/* T[ȍw|C^ */
	struct  sockaddr_in     sockname;			/* \Pbg̃AhX */
	struct  sockaddr_in     serversockaddr;		/* T[õAhX */
	int sockaddr_Size;							/* T[õAhX̃TCY */
	struct NTP_Packet	NTP_Send;				/* MNTPpPbg */
	struct NTP_Packet	NTP_Recv;				/* MNTPpPbg */
	fd_set rdps;
	struct timeval waittime;
	int selret;

	time_t Cur_time;							/* [J}V̎ */
	time_t ntp_time;							/* NTPT[o擾 */
	struct tm *lpNewLocalTime;					/* nɕϊNTPT[o̎ */
	SYSTEMTIME	Timecall;						/* [J}Vɐݒ肷鎞 */
	float	Splitseconds;

	BOOL sync_flag;								/* tO */
	char *p,*r,*t,wk[8];						/* Ɨp̈ */


	/* Ȃꍇ͈̐\ */
	if(argc < 2){
		fprintf(stderr,"sntpc NTPServer [-S]\n");
		return -1;
	}

	/* NTPT[oT */
	strcpy(svName,argv[1]);
	/* T[oɃ|[gԍw肵Ă΁A */
	for(p = svName;*p != ':' && *p != '\0';p++);
	if(*p == ':'){
		for(t = p + 1,r = wk;*t != '\0';t++,r++){
			*r = *t;
		}
		*r = '\0';
		port = (unsigned short)atoi(wk);

		*p = '\0';
	}

	/* -s XCb`w肳ĂΓtO𗧂Ă */
	if(argc == 3 && stricmp(argv[2],"-s") == 0){
		sync_flag = TRUE;
	}else{
		sync_flag = FALSE;
	}

	/*----------------------------------------------------------*/
	/*				NTPT[o玞擾					*/
	/*----------------------------------------------------------*/

	/* WinSock̏s */
	wVersionRequested = MAKEWORD(1,1);						/* o[W 1.1 v */
	nErrorStatus = WSAStartup(wVersionRequested, &wsaData);
	if(atexit((void (*)(void))(WSACleanup))){				/* IWinSock̃\[X悤ɂĂ */
		fprintf(stderr,"Error: atexit(WSACleanup)s\n");
		return -1;
	}
	if(nErrorStatus != 0){
		fprintf(stderr,"Error: WinSock̏s\n");
		return -1;
	}

	/* UDP[hsocɃ\Pbg쐬܂ */
	soc = socket(PF_INET,SOCK_DGRAM,0);
	if(soc == INVALID_SOCKET){
		fprintf(stderr,"Error: Socket쐬s\n");
		return -1;
	}

	/* \Pbg̃AhX̍\̂ɃT[oIPAhXƃ|[gԍݒ肵܂ */
	sockname.sin_family       = AF_INET;							/* C^[lbg̏ꍇ */
	sockname.sin_addr.s_addr  = INADDR_ANY;							/* IPAhXg悤ɂ */
	sockname.sin_port         = htons((unsigned short)local_port);	/* M|[gԍ */
	memset(sockname.sin_zero,(int)0,sizeof(sockname.sin_zero));
	if(bind(soc,(struct sockaddr *)&sockname,sizeof(sockname)) == SOCKET_ERROR){
		fprintf(stderr,"M|[gԍ̎wɎs\n");
	}

	/* svNameɃhbgt10iŕ\IPAhXĂꍇAserveraddr32bitIPAhXԂ܂ */
	serveraddr = inet_addr((char*)svName);
	if(serveraddr == -1) {
		/* T[o(svName)T[ȍ擾܂ */
		serverhostent = gethostbyname(svName);
		if(serverhostent == NULL) {
			fprintf(stderr,"Error: zXgAhX擾s\n");
			/* \Pbgj */
			closesocket(soc);
			return -1;
		}else{
			/* T[ȍ񂩂IPAhXserveraddrɃRs[܂ */
			serveraddr = *((unsigned long *)((serverhostent->h_addr_list)[0]));
		}
	}

	/* T[õAhX̍\̂ɃT[oIPAhXƃ|[gԍݒ肵܂ */
	serversockaddr.sin_family       = AF_INET;							/* C^[lbg̏ꍇ */
	serversockaddr.sin_addr.s_addr  = serveraddr;						/* T[oIPAhX */
	serversockaddr.sin_port         = htons((unsigned short)port);		/* |[gԍ */
	memset(serversockaddr.sin_zero,(int)0,sizeof(serversockaddr.sin_zero));

	/* NTPpPbgSNTPpɏ */
	NTP_Send.Control_Word = htonl(0x0B000000);
	NTP_Send.root_delay = 0;
	NTP_Send.root_dispersion = 0;
	NTP_Send.reference_identifier = 0;
	NTP_Send.reference_timestamp = 0;
	NTP_Send.originate_timestamp = 0;
	NTP_Send.receive_timestamp = 0;
	NTP_Send.transmit_timestamp_seconds = 0;
	NTP_Send.transmit_timestamp_fractions = 0;

	/* T[ow肵NTPpPbg𑗐M */
	if(sendto(soc,(const char *)&NTP_Send, sizeof( NTP_Send ),0,(struct sockaddr *)&serversockaddr,sizeof(serversockaddr)) == SOCKET_ERROR){
		fprintf(stderr,"Error: T[oւ̑Ms\n");
		/* \Pbgj */
		closesocket(soc);
		return -1;
	}

	/* select֐gă^CAEgݒ肷 */
	waittime.tv_sec = TIMEOUT;		/* ^CAEgbݒ肷 */
	waittime.tv_usec = 0;
	FD_ZERO(&rdps);
	FD_SET(soc,&rdps);				/* select\Pbgǉ */

	selret = select(FD_SETSIZE,&rdps,(fd_set *)0,(fd_set *)0,&waittime);
	if(selret == SOCKET_ERROR){					/* G[̏ꍇ */
		fprintf(stderr,"Error: T[o̎Ms\n");
		/* \Pbgj */
		closesocket(soc);
		return -1;
	}
	if(selret == 0){				/* ^CAEg̏ꍇ */
		fprintf(stderr,"Error: ^CAEg܂\n");
		/* \Pbgj */
		closesocket(soc);
		return -1;
	}
	if(FD_ISSET(soc,&rdps) == FALSE){	/* M͂Aw̃\Pbgł͂Ȃꍇ */
		fprintf(stderr,"Error: T[o̎Ms\n");
		/* \Pbgj */
		closesocket(soc);
		return -1;
	}

	/* T[ow肵ĎMs */
	sockaddr_Size = sizeof(serversockaddr);
	if(recvfrom(soc, (char *)&NTP_Recv, sizeof(NTP_Recv), 0,(struct sockaddr *)&serversockaddr,&sockaddr_Size) == SOCKET_ERROR ){
		fprintf(stderr,"Error: T[o̎Ms\n");
		/* \Pbgj */
		closesocket(soc);
		return -1;
	}

	/* \Pbgj */
	closesocket(soc);


	/*----------------------------------------------------------*/
	/*			NTPT[o擾ҏW				*/
	/*----------------------------------------------------------*/

	/* [J}V̎擾 */
	Cur_time = time(NULL);

	/* NTPT[o擾nԂɕϊ */
	ntp_time = ntohl(NTP_Recv.transmit_timestamp_seconds) - 2208988800;		/* 1970/01/01 ̕bɕϊ */
	lpNewLocalTime = localtime((unsigned int *)&ntp_time);
	if(lpNewLocalTime == NULL){
		fprintf(stderr,"Error: ̎擾s\n");
		return -1;
	}

	/* [JNTPT[o̎\ */
	printf("[J  = %s\n",ctime((unsigned int *)&Cur_time));
	printf("NTPT[o = %s\n",ctime((unsigned int *)&ntp_time));

	/* tOĂꍇ́A̓s */
	if(sync_flag == TRUE){
		/* [J̌vZ */
		Timecall.wYear = lpNewLocalTime->tm_year + 1900;
		Timecall.wMonth = lpNewLocalTime->tm_mon + 1;
		Timecall.wDay = lpNewLocalTime->tm_mday;
		Timecall.wHour = lpNewLocalTime->tm_hour;
		Timecall.wMinute = lpNewLocalTime->tm_min;
		Timecall.wSecond = lpNewLocalTime->tm_sec;

		Splitseconds = (float)ntohl(NTP_Recv.transmit_timestamp_fractions);
		Splitseconds = (float)0.000000000200 * Splitseconds;
		Splitseconds = (float)1000.0 * Splitseconds;
		Timecall.wMilliseconds = (unsigned short)Splitseconds;

		/* [JNTPT[o擾ɐݒ肷 */
		if(SetLocalTime(&Timecall) == TRUE){
			printf("NTPT[o̎ɓ܂\n");
		}else{
			fprintf(stderr,"Error: ̐ݒɎs\n");
		}
	}
	return 0;
}
